"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.authorize = void 0;
// Config
const ts_serverless_authentication_1 = require("ts-serverless-authentication");
const policyContext = (data) => {
    let context = {};
    const validTypes = ['boolean', 'number', 'string'];
    for (const [key, value] of Object.entries(data)) {
        if (key !== 'id' && validTypes.indexOf(typeof value) !== -1) {
            context[key] = value;
        }
    }
    return context;
};
// Authorize
async function authorize(event) {
    const stage = event.methodArn.split('/')[1] || 'dev'; // @todo better implementation
    let error = null;
    let policy = {};
    const { authorizationToken } = event;
    if (authorizationToken) {
        try {
            // this example uses simple expiration time validation
            const providerConfig = ts_serverless_authentication_1.config({ provider: '', stage });
            if (!providerConfig.token_secret)
                throw new Error('Authorize: No token secret configured.');
            const data = ts_serverless_authentication_1.utils.readToken(authorizationToken, providerConfig.token_secret);
            policy = ts_serverless_authentication_1.utils.generatePolicy(data.id, 'Allow', event.methodArn);
            policy.context = policyContext(data);
        }
        catch (err) {
            error = 'Unauthorized';
        }
    }
    else {
        error = 'Unauthorized';
    }
    if (policy === {}) {
        error = 'No policy.';
    }
    if (error) {
        throw new Error(error);
    }
    return policy;
}
exports.authorize = authorize;
//# sourceMappingURL=authorizeHandler.js.map