"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.signinHandler = void 0;
// Config
const ts_serverless_authentication_1 = require("ts-serverless-authentication");
// Providers
// import * as facebook from 'serverless-authentication-facebook';
// import * as google from 'serverless-authentication-google';
// import * as microsoft from 'serverless-authentication-microsoft';
const customGoogle = __importStar(require("../custom-google"));
// Common
const dynamoCache_1 = require("../storage/dynamo/dynamoCache");
const cache = new dynamoCache_1.dynamoCache({ region: 'us-west-2', endpoint: 'http://localhost:8000' });
/**
 * Signin Handler
 * @param proxyEvent
 * @param context
 */
async function signinHandler(proxyEvent) {
    const event = {
        provider: proxyEvent.pathParameters.provider,
        stage: proxyEvent.requestContext.stage,
        host: proxyEvent.headers.Host
    };
    const providerConfig = ts_serverless_authentication_1.config(event);
    let data;
    try {
        const state = await cache.createState();
        if (!state) {
            throw new Error('State is unassigned.');
        }
        switch (event.provider) {
            // case 'facebook':
            //   data = facebook.signinHandler(providerConfig, {
            //     scope: 'email',
            //     state
            //   });
            //   break;
            // case 'google':
            //   data = google.signinHandler(providerConfig, {
            //     scope: 'profile email',
            //     state
            //   });
            //   break;
            // case 'microsoft':
            //   data = microsoft.signinHandler(providerConfig, {
            //     scope: 'wl.basic wl.emails',
            //     state
            //   });
            //   break;
            case 'custom-google':
                // See ./customGoogle.js
                data = await customGoogle.signinHandler(providerConfig, { state });
                break;
            default:
                data = ts_serverless_authentication_1.utils.errorResponse({ error: `Invalid provider: ${event.provider}` }, providerConfig);
                break;
        }
    }
    catch (exception) {
        console.log('Caught in signinHandler');
        data = ts_serverless_authentication_1.utils.errorResponse({ exception }, providerConfig);
    }
    return {
        statusCode: 302,
        headers: {
            Location: data.url
        }
    };
}
exports.signinHandler = signinHandler;
//# sourceMappingURL=signinHandler.js.map