import { Cacheable } from '../abstract/Cacheable';
export declare class dynamoCache extends Cacheable {
    private config;
    private dynamodb;
    constructor(config?: {
        region: string;
        endpoint?: string;
    });
    /**
     * Creates OAuth State
     */
    createState: () => Promise<string>;
    /**
     * Revokes OAuth State
     * @param state
     */
    revokeState: (state: string) => Promise<string>;
    /**
     * Creates and saves refresh token
     * @param user
     */
    saveRefreshToken: (user: string, payload: object) => Promise<string>;
    /**
     * Revokes old refresh token and creates new
     * @param oldToken
     */
    revokeRefreshToken: (oldToken: string) => Promise<{
        id: string;
        token: string;
        payload: any;
    }>;
}
