"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const AWS = __importStar(require("aws-sdk"));
// empty strings cannot be saved to dynamo
const sanitize = (obj) => {
    const clone = Object.assign({}, obj);
    Object.keys(clone).forEach((key) => {
        if (key === '_raw') {
            clone[key] = sanitize(clone[key]);
        }
        else if (clone[key] === '' || clone[key] === undefined) {
            delete clone[key];
        }
    });
    return clone;
};
const saveUser = async (profile) => {
    const config = {
        region: process.env.REGION || 'eu-west-1'
    };
    const dynamodb = new AWS.DynamoDB.DocumentClient(config);
    const params = {
        TableName: process.env.USERS_DB_NAME || '',
        Item: sanitize(profile)
    };
    return await dynamodb.put(params).promise();
};
exports.default = saveUser;
//# sourceMappingURL=dynamoUser.js.map