"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts_mock_imports_1 = require("ts-mock-imports");
const AWS = __importStar(require("aws-sdk"));
const signinHandler_1 = require("../authentication/lib/handlers/signinHandler");
const chai_1 = require("chai");
require("mocha");
const docMock = ts_mock_imports_1.ImportMock.mockClass(AWS.DynamoDB, 'DocumentClient');
docMock.mock('put', Promise.resolve({}));
afterEach(() => {
    ts_mock_imports_1.ImportMock.restore();
});
describe('Authentication', () => {
    beforeEach(() => {
        process.env.STAGE = 'dev';
        process.env.CACHE_DB_NAME = 'dev-serverless-authentication-cache';
        process.env.REDIRECT_CLIENT_URI = 'http://127.0.0.1:3000/';
        process.env.TOKEN_SECRET = 'token-secret-123';
    });
    describe('Signin', () => {
        it('should fail to return token for invalid provider', async () => {
            const event = {
                pathParameters: {
                    provider: 'invalid'
                },
                requestContext: {
                    stage: 'dev'
                },
                headers: {
                    Host: 'api-id.execute-api.eu-west-1.amazonaws.com'
                }
            };
            const data = await signinHandler_1.signinHandler(event);
            chai_1.expect(data.statusCode).to.equal(302);
            chai_1.expect(data.headers.Location).to.be.equal('http://127.0.0.1:3000/?exception=Error: createState: UnrecognizedClientException: The security token included in the request is invalid.');
        }).timeout(10000);
    });
});
//# sourceMappingURL=authentication-fail.test.js.map