"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ts_serverless_authentication_1 = require("ts-serverless-authentication");
const authorizeHandler_1 = require("../authentication/lib/handlers/authorizeHandler");
const chai_1 = require("chai");
require("mocha");
describe('Authorization', () => {
    beforeEach(() => {
        process.env.STAGE = 'dev';
        process.env.CACHE_DB_NAME = 'dev-serverless-authentication-cache';
        process.env.REDIRECT_CLIENT_URI = 'http://127.0.0.1:3000/';
        process.env.TOKEN_SECRET = 'token-secret-123';
    });
    describe('Authorize', () => {
        it('should return policy', async () => {
            const payload = { id: 'username-123' };
            const providerConfig = ts_serverless_authentication_1.config({ provider: '', stage: 'dev' });
            const authorizationToken = ts_serverless_authentication_1.utils.createToken(payload, providerConfig.token_secret || '');
            const event = {
                type: 'TOKEN',
                authorizationToken,
                methodArn: 'arn:aws:execute-api:<regionId>:<accountId>:<apiId>/dev/<method>/<resourcePath>'
            };
            const data = await authorizeHandler_1.authorize(event);
            chai_1.expect(data.principalId).to.be.equal(payload.id);
        });
    });
});
//# sourceMappingURL=authorization.test.js.map